#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: bandwidth.pl,v 1.20 2001/11/06 07:09:47 uzi Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
# Author: Joshua Uziel

use CCE;
use Sauce::Util;
use Sauce::Service;

$bw_setip_prog = '/sbin/bw_setip';

my $cce = new CCE;
$cce->connectfd();

# Get the bandwidth object
my ($bw_ok, $bwoid) = $cce->get($cce->event_oid());
if (not $bw_ok) {
	$cce->bye('FAIL');
	exit(1);
}

if ($bwoid->{bwlimit} >= 10) {
	bw_setip($bwoid->{ipaddr}, $bwoid->{bwlimit});
} else {
	$cce->bye('FAIL', '[[base-bandwidth.valuelow]]');
	exit(1);
}

$cce->bye('SUCCESS');
exit(0);

#--------------------------------------------------------------------------#
# Subroutines
#--------------------------------------------------------------------------#

sub bw_setip
{
	my ($ipaddr, $bwlimit)  = @_;

	my $limit = $bwlimit * 128;	# 1024/8 = 128

	my $direction = 'w';
	my $protocol  = 'tcp';

	# Set port if needed.
	my $protport = "-p $protocol";
	$protport .= "/$port" if ($port);

	my @cmdline = ("$bw_setip_prog", "-i $ipaddr", "-b $limit");
	@cmdline = (@cmdline, $protport);
	@cmdline = (@cmdline, " -t $direction") if ($direction);
#ROLLBACK SPECIAL
	my $ret = system("@cmdline > /dev/null 1>&2");
	if ($ret) {
		$cce->bye('FAIL', '[[base-bandwidth.setlimitfail]]');
		exit 1;
	}

	# Write info to the file... this is for when the system starts up.
	my %settings;

	# CCE limit is in kbps, we want bps.
	$settings{'BWLIMIT'} = $limit;
	$settings{'IP'} = $ipaddr;

	$ret = Sauce::Util::editfile("/etc/sysconfig/bwmgmt/$ipaddr.conf",
		*Sauce::Util::keyvalue_edit_fcn, '#', '=', undef, %settings);
	unless ($ret) {
		$cce->bye('FAIL', '[[base-bandwidth.cantsetipfile]]');
		exit 1;
	}

	return $ret;
}
